# Simple Classes by MiB
import es
import popuplib
import keyvalues
import random
import playerlib
import langlib
import weaponlib
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Simple Classes"
info.author = "MiB"
info.version = "1.0.2"
info.url = "www.sddcommunity.com"
info.basename = "cl"

def cl_handle(userid,choice,popupname):
    player = playerlib.getPlayer(userid)
    Player(userid).Damage(userid,player.getHealth())
    Stats(userid).SetStats(choice)
    strings["class"] = choice
    es.tell(userid,"#multi",lang("tag",{},player.get("lang")) + lang("newclass",strings,player.get("lang")))

cl_primarys = "m3,xm1014,mac10,tmp,mp5navy,ump45,p90,galil,famas,ak47,m4a1,scout,sg550,aug,awp,g3sg1,sg552,m249"
cl_machineguns = "m249"
cl_shotguns = "m3,xm1014"
cl_smgs = "mac10,tmp,mp5navy,ump45,p90"
cl_rifles = "galil,famas,ak47,m4a1,aug"
cl_snipers = "awp,g3sg1,sg552,scout,sg550"
cl_secondarys = "glock,usp,p228,deagle,elite,fiveseven"
cl_grenades = "hegrenade,smokegrenade,flashbang"
es.ServerVar("scl_version",info.version,"Simple Classes version public variable.").makepublic()
lang = langlib.Strings(es.ServerVar("eventscripts_gamedir") + "/cfg/eventscripts/cl/cl.ini")
strings = {}
es.keygroupload("cl","eventscripts/cl")
cl_classes = keyvalues.getKeyGroup("cl")
cl_menu = popuplib.easymenu("cl_menu",None,cl_handle)
cl_menu.settitle(lang("menutitle",{},"en"))
for cl_class in cl_classes: cl_menu.addoption(cl_class.getName(),(cl_class.getName() + "\n" +cl_classes[cl_class.getName()]["description"]))
cl_players = {}


class Player():
    def __init__(self,userid):
        self.userid = int(userid)
        self.player = playerlib.getPlayer(self.userid)
    def Give(self,item): es.server.queuecmd("es_xgive %s %s"%(self.userid,item))
    def Damage(self,target,damage):
        tar = playerlib.getPlayer(target)
        health = tar.getHealth()
        if tar.isdead: return
        if damage < health:
            tar.setHealth((health - damage))
        else:
            entity = es.createentity("point_hurt")
            es.entitysetvalue(entity,"targetname","cl_damage")
            es.entitysetvalue(entity,"damage",damage)
            es.entitysetvalue(entity,"damagetype",32)
            es.entitysetvalue(entity,"damagetarget","cl_target")
            es.entitysetvalue(entity,"classname",self.getProp("weapon"))
            es.fire(target,"!self","addoutput","targetname cl_target")
            es.fire(self.userid,"cl_damage","hurt")
            es.fire(self.userid,"cl_damage","kill")
            es.fire(target,"!self","addoutput","targetname cl_player")
    def Strip(self):
        entity = es.createentity("player_weaponstrip")
        es.entitysetvalue(entity,"targetname","cl_strip")
        es.fire(self.userid,"cl_strip","strip")
        es.fire(self.userid,"cl_strip","kill")
        self.Give("weapon_knife")
    def LongJump(self,multi):
        multi = float(multi)
        vel = self.getVel()
        es.setplayerprop(self.userid,"CBasePlayer.localdata.m_vecBaseVelocity","%s,%s,0"%((vel[0] * multi),(vel[1] * multi)))
    def RemoveWeapon(self,weapon):
        if not weapon.startswith("weapon_"): weapon = "weapon_" + weapon
        handle = es.getplayerhandle(self.userid)
        for entity in es.createentitylist(weapon):
            if es.getindexprop(entity,"CBaseEntity.m_hOwnerEntity") == handle:
                es.remove(entity)
                break
        es.cexec(self.userid,"lastinv")
    def setGrav(self,grav): es.entitysetvalue(self.player.index,"gravity",float(grav))
    def getGrav(self): return es.entitygetvalue(self.player.index,"gravity")
    def getVel(self):
        vel = es.getplayerprop(self.userid,"CBasePlayer.localdata.m_vecBaseVelocity").split(",")
        for ve in vel: vel[vel.index(ve)] = float(ve)
        return vel
    def getProp(self,prop): return es.createplayerlist(self.userid)[self.userid][prop]

class Stats():
    def __init__(self,userid):
        self.userid = int(userid)
        self.player = playerlib.getPlayer(userid)
        self.cplayer = Player(userid)
    def SetStats(self,cl_class):
        cl_players[self.userid]["class"] = cl_class
        cl_players[self.userid]["primary"] = str(cl_classes[cl_class]["primary"])
        cl_players[self.userid]["secondary"] = str(cl_classes[cl_class]["secondary"])
        cl_players[self.userid]["health"] = int(cl_classes[cl_class]["health"])
        cl_players[self.userid]["speed"] = float(cl_classes[cl_class]["speed"])
        cl_players[self.userid]["longjump"] = float(cl_classes[cl_class]["longjump"])
        cl_players[self.userid]["lowgrav"] = float(cl_classes[cl_class]["lowgrav"])
        cl_players[self.userid]["armor"] = int(cl_classes[cl_class]["armor"])
        cl_players[self.userid]["damage"] = int(cl_classes[cl_class]["damage"])
        cl_players[self.userid]["strip"] = int(cl_classes[cl_class]["strip"])
        cl_players[self.userid]["nades"] = str(cl_classes[cl_class]["nades"]).split(",")
        cl_players[self.userid]["restrict"] = str(cl_classes[cl_class]["restrict"]).replace("#primarys",cl_primarys).replace("#secondarys",cl_secondarys).replace("#grenades",cl_grenades).replace("#smgs",cl_smgs).replace("#shotguns",cl_shotguns).replace("#snipers",cl_snipers).replace("#rifles",cl_rifles).replace("#machineguns",cl_machineguns).split(",")
    def ResetStats(self):
        cl_players[self.userid] = {}
        self.SetStats(random.choice(cl_classes.keys()))
    def SendMenu(self):
        cl_menu.settitle(lang("menutitle",{},self.player.get("lang")))
        popuplib.send("cl_menu",self.userid)
    def TellClass(self):
        strings["class"] = cl_players[self.userid]["class"]
        es.tell(self.userid,"#multi",lang("tag",{},self.player.get("lang")) + lang("currentclass",strings,self.player.get("lang")))
    def SpawnPerks(self):
        if cl_players[self.userid]["strip"] != 0: self.cplayer.Strip()
        if cl_players[self.userid]["primary"] != "0": self.cplayer.Give(cl_players[self.userid]["primary"])
        if cl_players[self.userid]["secondary"] != "0": self.cplayer.Give(cl_players[self.userid]["secondary"])
        if cl_players[self.userid]["health"] != 0: self.player.setHealth(cl_players[self.userid]["health"])
        if cl_players[self.userid]["speed"] != 0.0: self.player.setSpeed(cl_players[self.userid]["speed"])
        if cl_players[self.userid]["armor"] != 0: self.player.setArmor(cl_players[self.userid]["armor"])
        if cl_players[self.userid]["lowgrav"] != 0.0: self.cplayer.setGrav(cl_players[self.userid]["lowgrav"])
        if cl_players[self.userid]["nades"] != ["0"]:
            if "weapon_hegrenade" in cl_players[self.userid]["nades"] and self.player.getHE() == 0: self.cplayer.Give("weapon_hegrenade")
            if "weapon_flashbang" in cl_players[self.userid]["nades"] and self.player.getFB() == 0: self.cplayer.Give("weapon_flashbang")
            if "weapon_smokegrenade" in cl_players[self.userid]["nades"] and self.player.getSG() == 0: self.cplayer.Give("weapon_smokegrenade")
    def AttackerPerks(self,attacker,weapon):
        if cl_players[self.userid]["damage"] > 0: self.cplayer.damage(attacker,cl_players[self.userid]["damage"])
    def JumpPerks(self):
        if cl_players[self.userid]["lowgrav"] != 0.0: self.cplayer.setGrav(cl_players[self.userid]["lowgrav"])
        if cl_players[self.userid]["longjump"] != 0.0: self.cplayer.LongJump(cl_players[self.userid]["longjump"])
    def Restrict(self,weapon):
        if cl_players[self.userid]["restrict"] != ["0"]:
            if weapon not in cl_players[self.userid]["restrict"]: return
            strings["weapon"] = weapon.capitalize()
            es.centertell(self.userid,lang("restriction",strings,self.player.get("lang")))
            self.cplayer.RemoveWeapon(weapon)

def round_start(ev):
    strings["version"] = info.version
    for userid in es.getUseridList(): es.tell(userid,"#multi",(lang("tag",{},playerlib.getPlayer(userid).get("lang")) + lang("roundmessage",strings,playerlib.getPlayer(userid).get("lang"))))

def player_spawn(ev):
    userid = int(ev["userid"])
    stats = Stats(userid)
    if userid not in cl_players: stats.ResetStats()
    if playerlib.getPlayer(userid).isdead: return
    stats.SpawnPerks()
    stats.TellClass()

def player_hurt(ev):
    userid = int(ev["userid"])
    stats = Stats(userid)
    if int(ev["health"]) > 0 or ev["weapon"] == "point_hurt" or ev["userid"] == ev["attacker"] or userid not in cl_players: return
    stats.AttackerPerks(ev["attacker"])

def player_say(ev):
    userid = int(ev["userid"])
    stats = Stats(userid)
    if userid not in cl_players: stats.ResetStats()
    if ev["text"].lower() == "!classes" or ev["text"].lower() == "!class" or ev["text"].lower() == "!cl": stats.SendMenu()
    elif ev["text"].lower() == "!myclass" or ev["text"].lower() == "!mc": stats.TellClass()

def player_disconnect(ev):
    userid = int(ev["userid"])
    if userid in cl_players: del cl_players[userid]

def player_jump(ev):
    userid = int(ev["userid"])
    if userid not in cl_players: return
    Stats(userid).JumpPerks()

def item_pickup(ev):
    userid = int(ev["userid"])
    if userid not in cl_players or ev["item"] == "knife" or weaponlib.getWeapon(ev["item"]) is None: return
    Stats(userid).Restrict(ev["item"])

def unload():
    es.keygroupdelete("classes_database")
    popuplib.delete("cl_menu")
